package br.edu.fei.dcc.raciocinioespacial.editor.commands;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IWorkbenchWindow;

import br.edu.fei.dcc.raciocinioespacial.editor.application.Application;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.ShapesEditor;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.ShapesEditorInput;
import br.edu.fei.dcc.raciocinioespacial.simulador.persistencia.PersistenciaSimulacao;
import br.edu.fei.dcc.raciocinioespacial.simulador.simulacao.Simulacao;

public class OpenScenaryAction extends Action {
	
	IWorkbenchWindow workbenchWindow;
	
	public OpenScenaryAction(IWorkbenchWindow window) {
		super.setId("newShape");
		super.setText("Open Scenary");
		super.setImageDescriptor(ImageDescriptor.createFromFile(Application.class, "icons/new.png"));
		this.workbenchWindow = window;
	}
	
	public void run() {
		String sPath = Utils.openFileDialog(workbenchWindow, "Open Scenary", "*.sce", SWT.OPEN);
		if (sPath != null) {
			
			try {
				Simulacao simOpen = new PersistenciaSimulacao(sPath).obter();
				
				if (sPath.lastIndexOf(".") >= 0)
					sPath = sPath.substring(0, sPath.lastIndexOf("."));
				sPath += "1.stv";
				
				IEditorInput input = new ShapesEditorInput(new Path(sPath), sPath);
				
				workbenchWindow.getActivePage().openEditor(
						input, 
						ShapesEditor.ID, 
						true);
				((ShapesEditorInput)input).setShapesDiagram(new Transformacao(simOpen, ((ShapesEditorInput)input).getShapesDiagram()).getDiagram());
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
