package br.edu.fei.dcc.raciocinioespacial.editor.commands;

import org.eclipse.core.runtime.Path;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IWorkbenchWindow;

import br.edu.fei.dcc.raciocinioespacial.editor.application.Application;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.ShapesEditor;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.ShapesEditorInput;
import br.edu.fei.dcc.raciocinioespacial.simulador.persistencia.PersistenciaSimulacao;
import br.edu.fei.dcc.raciocinioespacial.simulador.simulacao.Simulacao;

public class OpenSimAction extends Action {
	
	IWorkbenchWindow workbenchWindow;
	
	public OpenSimAction(IWorkbenchWindow window) {
		super.setId("openShapes");
		super.setText("Open Simulation");
		super.setImageDescriptor(ImageDescriptor.createFromFile(Application.class, "icons/open.png"));
		this.workbenchWindow = window;
	}
	
	public void run() {
		String path = Utils.openFileDialog(workbenchWindow, "Open Simulation", "*.stv", SWT.OPEN);
		if (path != null) {
			
			try {
				Simulacao simAberta = new PersistenciaSimulacao(path).obter();
				IEditorInput input = new ShapesEditorInput(new Path(path), simAberta.getNome());
				workbenchWindow.getActivePage().openEditor(
						input, 
						ShapesEditor.ID, 
						true);
				((ShapesEditorInput)input).setShapesDiagram(new Transformacao(simAberta, ((ShapesEditorInput)input).getShapesDiagram()).getDiagram());
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}