package br.edu.fei.dcc.raciocinioespacial.editor.commands;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IWorkbenchWindow;

import br.edu.fei.dcc.raciocinioespacial.editor.application.Application;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.ShapesEditor;

public class SaveSimAction extends Action {
	
	IWorkbenchWindow workbenchWindow;
	
	public SaveSimAction(IWorkbenchWindow window) {
		super.setId("saveShapes");
		super.setText("Save Simulation");
		super.setImageDescriptor(ImageDescriptor.createFromFile(Application.class, "icons/save.png"));
		this.workbenchWindow = window;
	}
	
	public void run() {
		if(workbenchWindow.getActivePage().getActiveEditor()!=null)
		{
			ShapesEditor editor = (ShapesEditor)workbenchWindow.getActivePage().getActiveEditor();
			editor.doSaveAs();
		}else
		{
			MessageDialog.openWarning(workbenchWindow.getShell(), "Erro ao salvar a simulao", "No existe nenhuma simulao ativa para ser salva.");
		}
		
	}
}