package br.edu.fei.dcc.raciocinioespacial.editor.shapes.elements;
import org.eclipse.swt.graphics.Image;

import br.edu.fei.dcc.raciocinioespacial.editor.shapes.properties.NumericProperty;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.properties.NumericPropertyTypeEnum;


/**
 * The shape for the agent.
 */
public class Agent2DShape extends Vehicle2DShape {

	private static final String Property_Depth = "shapes.depth";
	private static final String Property_Angle = "shapes.angle";
	private static final long serialVersionUID = 1;
	private int iDepth;
	private float fAngle;
	
	@Override
	protected void criaPropriedades() {
		this.getDescriptors().add(new NumericProperty(Property_Depth, "Depth", NumericPropertyTypeEnum.Integer));
		this.getDescriptors().add(new NumericProperty(Property_Angle, "Angle", NumericPropertyTypeEnum.Float));
		super.criaPropriedades();
	}
	
	public float getAngulo() {
		return fAngle;
	}
	
	@Override
	public Image getIcon() {
		return super.createImage("icons/observador.png");
	}
	
	public int getProfundidade() {
		return iDepth;
	}
	
	@Override
	public Object getPropertyValue(Object propertyId) {
		if (Property_Depth.equals(propertyId)) {
			return Integer.toString(this.getProfundidade());
		}
		if (Property_Angle.equals(propertyId)) {
			return Float.toString(this.getAngulo());
		}
		return super.getPropertyValue(propertyId);
	}

	@Override
	protected void inicia() {
		super.inicia();
		this.iDepth = 600;
		this.fAngle = 120;
		this.name = "Agent";
	}

	public void setAngulo(float angulo) {
		this.fAngle = angulo;
	}

	public void setProfundidade(int profundidade) {
		this.iDepth = profundidade;
	}

	@Override
	public void setPropertyValue(Object propertyId, Object value) {
		if (Property_Depth.equals(propertyId)) {
			int profundidade = Integer.parseInt((String)value);
			this.setProfundidade(profundidade);
		}
		if (Property_Angle.equals(propertyId)) {
			float angulo = Float.parseFloat((String)value);
			this.setAngulo(angulo);
		}
		super.setPropertyValue(propertyId, value);
	}

	@Override
	public String toString() {
		return this.getName();
	}
}
