/**
 * 
 */
package br.edu.fei.dcc.raciocinioespacial.editor.shapes.elements;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.swt.graphics.Image;

import br.edu.fei.dcc.raciocinioespacial.simulador.util.SentidoVehicle;

/**
 * The shape for a vehicle
 */
public class Vehicle2DShape extends Mobile2DShape {
	private static final long serialVersionUID = 1;
	private SentidoVehicle svSentido = SentidoVehicle.VERTICAL;
	
	@Override
	/** Returns the image icon used to represent cars into editor */
	public Image getIcon() {
		return super.createImage("icons/vehicle.png");
	}
	
	/** Initiate the object with default configuration */
	protected void inicia() {
		super.inicia();
		this.setVelocity(2.0f);
		this.name = "Vehicle";
		this.setSize(new Dimension(10, 18));
	}

	/** Returns the actual direction set for the car */
	public SentidoVehicle getSentido() {
		return svSentido;
	}

	/** Set an direction for the car */
	public void setSentido(SentidoVehicle direction) {
		svSentido = direction;
	}
}
