package br.edu.fei.dcc.raciocinioespacial.simulador.persistencia;

import java.io.File;
import java.io.FileWriter;
import java.io.OutputStreamWriter;
import java.io.Serializable;

import br.edu.fei.dcc.raciocinioespacial.simulador.perfilprofundidade.CampoVisaoInstantaneo;
import br.edu.fei.dcc.raciocinioespacial.simulador.simulacao.Simulacao;

public class SaidaPerfilProfundidade implements IPersistencia {

	private static final String INICIO = "leftBorder";
	private static final String FIM = "rightBorder";
	private static final String EXTENSAO = "pl";
	private static final String CABECALHO = "description";
	private static final String BACKGROUND = "background";
	private static final String FOREGROUND = "foreground";
	private Simulacao simulacao;
	
	public SaidaPerfilProfundidade(Simulacao simulacao) {
		super();
		this.simulacao = simulacao;
	}

	public Serializable obter() throws Exception {
		return null;
	}

	private String getDescricaoPerfilProfundidade(int t)
	{		
		return String.format("%s(t%d,[%s]).\n", CABECALHO, t, this.getDescricaoPerfilProfundidade(this.simulacao.getProfile().getCampoVisaoInstantaneo()));
	}	
	
	private String getDescricaoPerfilProfundidade(CampoVisaoInstantaneo cvi) {
		if(cvi!=null)
		{
			StringBuilder conteudo = new StringBuilder();
			
			/*for(int i=0; i<cvi.getParteCampo().size(); i++)
			{
				String tipo;
				int profundidade, tamanho;
				if(cvi.getParteCampo().get(i).getInstersecaoComObservador()!=null)
				{
					tipo = FOREGROUND;
					profundidade = cvi.getParteCampo().get(i).getProfundidade();
				}else
				{
					tipo = BACKGROUND;
					profundidade = -1;
				}
				tamanho = this.getTamanho(cvi, i);
				if(i>0) conteudo.append(",");
				conteudo.append(String.format("%s(%s, %d, %d)", tipo, this.getRotulo(cvi, i, tamanho), profundidade, (int)((tamanho+1)*this.simulacao.getProfile().getFator())));
				i+=tamanho;
			}*/
			return conteudo.toString();
		}
		
		return null;
	}

	private String getRotulo(CampoVisaoInstantaneo cvi, int inicio, int tamanho) {
		/*if(cvi.getParteCampo().get(inicio).getInstersecaoComObservador()==null)
		{
			String a, b;
			if(inicio==0) 
				a = INICIO;
			else
				a = cvi.getParteCampo().get(inicio-1).getInstersecaoComObservador().getNome();
			
			if((inicio+tamanho)>=(cvi.getParteCampo().size()-1)) 
				b = FIM;
			else
				b = cvi.getParteCampo().get(inicio+tamanho+1).getInstersecaoComObservador().getNome();
			return String.format("(%s,%s)", a, b);
		}else
		{
			return cvi.getParteCampo().get(inicio).getInstersecaoComObservador().getNome();
		}*/return "?";
	}

	private int getTamanho(CampoVisaoInstantaneo cvi, int inicio) {
		/*if(cvi!=null)
		{
			boolean intersectando = (cvi.getParteCampo().get(inicio).getInstersecaoComObservador()!=null);
			int fim = 0;
			for(fim=inicio; fim<cvi.getParteCampo().size(); fim++)
			{
				if((cvi.getParteCampo().get(fim).getInstersecaoComObservador()!=null)!=intersectando)
					break;
			}
			return (fim-inicio-1);
		}*/
		return 0;
	}

	private String getDescricaoPerfilProfundidade()
	{
		/*StringBuilder sb = new StringBuilder();
		int qtd = (int)(this.simulacao.getProfile().getTMaximo()/this.simulacao.getIntervalo());
		for(int t=0; t<qtd; t++)
		{
			sb.append(this.getDescricaoPerfilProfundidade(t));
		}
		return sb.toString();*/return null;
	}
	
	public boolean salvarPerfilProfundidade()
	{
		/*try
		{
			this.salvar();
			return true;
		}catch(Exception e)
		{*/
			return false;
		//}
	}
	
	public void salvar() throws Exception {
		if(this.simulacao!=null)
		{
			OutputStreamWriter out = null;
			String nomeArquivo = (String.format("%s.%s", this.simulacao.getNome(), EXTENSAO));
			try
			{
				File f = new File(nomeArquivo);
				if(f.exists())
					f.delete();
				out = new FileWriter(nomeArquivo);
				out.write(this.getDescricaoPerfilProfundidade());
				out.flush();
			}finally
			{
				if(out!=null)
					out.close();
			}
		}
	}

}
