/**
 * 
 */
package br.edu.fei.dcc.raciocinioespacial.simulador.entidades;

import java.awt.Color;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.Rectangle;
import java.awt.geom.Rectangle2D;
import java.awt.geom.RectangularShape;
import java.util.ArrayList;

import br.edu.fei.dcc.raciocinioespacial.simulador.util.SentidoVehicle;

public class Vehicle2D extends Pedestrian2D {
	//private static final int FATOR_CORRECAO_DIRECAO = 12;

	private static final long serialVersionUID = 1L;

	private float[] direcao;

	public Vehicle2D(int x, int y, int width, int height, String nome){
		this(x,y,width,height,nome, Color.WHITE, new ArrayList<Point>());
	}

    public Vehicle2D()
	{
		this(0, 0, 0, 10, "veh");
	}
	
	/**
	 */
	public Vehicle2D(int x, int y, int width, int height, String nome, Color cor, ArrayList<Point> pontos){
		super(x,y,width,height,nome,cor,pontos);
	}

	/**
	 * Getter of the property <tt>direcao</tt>
	 * @return  Returns the direcao.
	 * @uml.property  name="direcao"
	 */
	public float[] getDirecao() {
		return direcao;
	}


	/**
	 * Setter of the property <tt>direcao</tt>
	 * @param direcao  The direcao to set.
	 * @uml.property  name="direcao"
	 */
	public void setDirecao(float direcao, int index) {
		if(direcao<0)
			this.direcao[index] = direcao + (float)(Math.toDegrees(2*Math.PI));
		else	
			this.direcao[index] = direcao;
	}
	
	public RectangularShape getObjeto2D()
	{
		// It verifies if the car is located correctly
		if (iHeight > iWidth)
		{
			if (svSentido == SentidoVehicle.HORIZONTAL)
			{
				// invert positions
				int iAux = iHeight;
				iHeight = iWidth;
				iWidth = iAux;
			}
		}
		else
		{
			if (svSentido == SentidoVehicle.VERTICAL)
			{
				// invert positions
				int iAux = iHeight;
				iHeight = iWidth;
				iWidth = iAux;
			}
		}
		
		obj2DOld = new Rectangle2D.Float(xCurrent, yCurrent, this.getWidth(), this.getHeight()); 
		return obj2DOld;
	}
	
	/*public void calculaDirecoes()
	{
		if((this.getPercurso()!=null)&&(this.getPercurso().npoints>1))
			this.calculaDirecoes(this.getPercurso());
		else if((this.getPontos()!=null)&&(this.getPontos().npoints>1))
			this.calculaDirecoes(this.getPontos());
	}*/
	
	public void calculaDirecoes(Polygon percurso)
	{
		this.direcao = new float[percurso.npoints];
		// TODO Estudar esse mecanismo
		/*
		for(int i=0; i<this.direcao.length; i++)
		{
			if((i%Agent2D.FATOR_CORRECAO_DIRECAO!=0)||(i==this.direcao.length-1))
			{
				this.setDirecao(this.getDirecao()[i-1], i);
			}
			else
			{					
				int x0 = percurso.xpoints[i];
				int y0 = percurso.ypoints[i];
				int x1 = percurso.xpoints[i+1];
				int y1 = percurso.ypoints[i+1];
			
				double direcao = Utils.getAnguloAgudoEntreRetas(x1, y0, x0, y0, x1, y1);
				
				if((x1<x0)&&(y1<y0))
				{
					//Segundo quadrante
					direcao = (Math.PI - direcao);
				}
				else if((x1<x0)&&(y1>y0))
				{
					//Terceiro quadrante
					direcao = (Math.PI + direcao);
				}
				else if((x1>x0)&&(y1>y0))
				{
					//Quarto quadrante
					direcao = (2*Math.PI - direcao);
				}
				else if(y1==y0)
				{
					if(x1>x0) 
						direcao = 0;
					else
						direcao = Math.PI;
				}else if(x0==x1)
				{
					if(y1>y0) 
						direcao = 3*Math.PI/2;
					else
						direcao = Math.PI/2;
				}
				
				this.setDirecao((float)Math.toDegrees(direcao)-this.getAngulo()/2, i);
			}				
		}*/
	}
	
	@Override
	public Rectangle getRect() {
		int dim = iWidth;
		if (iHeight > iWidth)
			dim = iHeight;
		
		dim = (int)(dim*0.7);
		
		return new Rectangle((int)xCurrent, (int)yCurrent, dim, dim);
	}
}