package br.edu.fei.dcc.raciocinioespacial.simulador.perfilprofundidade;

import java.awt.Point;
import java.awt.Rectangle;

import br.edu.fei.dcc.raciocinioespacial.simulador.entidades.Pedestrian2D;

public class ObstaculoCampoVisao {
	private float profundidade;
	private Pedestrian2D obstaculo;
	private Point ptIntersecao;
	private float fReferenceAngle;
	private float fInitialAngle;
	private float fFinalAngle;
	private float fOpeningAngle;
	private Rectangle rect;
	
	public ObstaculoCampoVisao(Pedestrian2D obstaculo, Rectangle rectangle) {
		super();
		//this.profundidade = profundidade;
		this.rect = rectangle;
		this.obstaculo = obstaculo;
		//this.ptIntersecao = ptIntersecao;
	}
	public Pedestrian2D getObstaculo() {
		return obstaculo;
	}
	public float getProfundidade() {
		return profundidade;
	}
	public Point getPtIntersecao() {
		return ptIntersecao;
	}
	public void setObstaculo(Pedestrian2D obst) {
		obstaculo = obst;
	}
	public void setProfundidade(float distancia) {
		profundidade = distancia;
	}
	public void setPtIntersecao(Point pt) {
		ptIntersecao = pt;
	}
	public float getOpeningAngle() {
		return fOpeningAngle;
	}
	public float getInitialAngle() {
		return fInitialAngle;
	}
	public float getFinalAngle() {
		return fFinalAngle;
	}
	public float getReferenceAngle() {
		return fReferenceAngle;
	}
	public void setAngles(float angleOpenning, float angleRefence) {
		fReferenceAngle = angleRefence;
		fOpeningAngle = angleOpenning;
		fInitialAngle = angleRefence - (angleOpenning/2);
		fFinalAngle = angleRefence + (angleOpenning/2);
	}
	public Rectangle getRect() {
		return rect;
	}
	public void trataOclusion(ObstaculoCampoVisao otherObst)
	{
		if (getFinalAngle()>otherObst.getInitialAngle())
		{
			if (getProfundidade() < otherObst.getProfundidade())
			{
				otherObst.fInitialAngle  = this.fFinalAngle;
				otherObst.fOpeningAngle = otherObst.fFinalAngle - otherObst.fInitialAngle;
			}
			else
			{
				this.fInitialAngle  = otherObst.fFinalAngle;
				this.fOpeningAngle = this.fFinalAngle - this.fInitialAngle;
			}
			
			if (otherObst.fOpeningAngle < 0)
				otherObst.fOpeningAngle = 0;
		}
	}
	public void trataPartialVision(float maxOpeningAngle)
	{
		if (fInitialAngle<0)
			this.fInitialAngle = 0;

		if (fFinalAngle<0)
			this.fFinalAngle = maxOpeningAngle;
		
		this.fOpeningAngle = this.fFinalAngle - this.fInitialAngle;
	}
}
